$(function() {
	$("#enableEvents").change(enableEventsChanged);
	refreshUi();
	setInterval(refreshUi, 20000);
});

function refreshUi() {
	refreshRelayStatuses();
	refreshSchedulingStatus();
	refreshEventsEnabled();
}

function enableEventsChanged() {
	$.ajax({
		method : "post",
		url : "/lights-scheduler/?eventsEnabled=" + $(this).is(":checked"),
		success : function(data) {
			refreshRelayStatuses();
		}
	});
}

function refreshEventsEnabled() {
	$.ajax({
		dataType : "text",
		url : "/lights-scheduler/events-enabled",
		success : function(data) {
			$("#enableEvents").prop("checked", data == "true");
		}
	});
}

function refreshSchedulingStatus() {
	$.ajax({
		dataType : "text",
		url : "/lights-scheduler/next-event-description",
		success : function(data) {
			$("#nextEventDescription").html(data);
		}
	});
}

function refreshSchedulingStatus() {
	$.ajax({
		dataType : "json",
		url : "/lights-scheduler/light-events",
		success : function(data) {
			var htmlTxt = "Schema:";
			$.each(data, function(index, element) {
	            htmlTxt += ("<br/>" + element.time + (element.lightsOn ? " (Lamporna tänds)" : " (Lamporna släcks)"));
	        });
			$("#lightsSchedule").html(htmlTxt);
		}
	});
}

function refreshRelayStatuses() {	
	$.ajax({
		dataType : "json",
		url : "/relays",
		success : function(data) {
			$.each(data, function(index, relay) {
				if (relay["powered"]) {					
					$("#gpio" + relay["gpio"] + "_on").hide();
					$("#gpio" + relay["gpio"] + "_off").show();
				} else {					
					$("#gpio" + relay["gpio"] + "_on").show();
					$("#gpio" + relay["gpio"] + "_off").hide();
				} 
			});
		}
	});
}

function powerRelay(gpio, powered) {
	$.ajax({
		method : "post",
		url : "/relays/" + gpio + "?powered=" + powered,
		success : function(data) {
			refreshRelayStatuses();
		}
	});
}