package se.paddbacken.relayservice.ui;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertSame;
import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

public class RelayServiceUIResourceTest {
	private RelayServiceUIResource resource;

	@Before
	public void setup() {
		resource = new RelayServiceUIResource(null);		
	}
	
	@Test
	public void shouldRedirectToMainPageWhenGettingDefault() throws Exception {
		assertEquals(307, resource.getDefault().getStatus());
	}

	@Test
	public void shouldReturnHttpNotFoundWhenGettingResourceThatDoesNotExist() throws Exception {
		assertEquals(404, resource.getUiResource("lkjghkjsdfbhxdsbnvkldfsknk").getStatus());
	}
	
	@Test
	public void shouldReturnStringEntityForTextBasedContent() throws Exception {
		assertTrue(resource.getUiResource("relays.js").getEntity() instanceof String);
		assertTrue(resource.getUiResource("relays.html").getEntity() instanceof String);
		assertTrue(resource.getUiResource("paddbacken.css").getEntity() instanceof String);
	}
	
	@Test
	public void shouldReturnByteArrayEntityForNonTextBasedContent() throws Exception {
		assertTrue(resource.getUiResource("paddis2.jpg").getEntity() instanceof byte[]);
		assertTrue(resource.getUiResource("bulb_off.png").getEntity() instanceof byte[]);
	}
	
	@Test
	public void shouldReturnCachedResourceWhenCalledMultipleTimes() throws Exception {
		assertSame(resource.getUiResource("paddis2.jpg").getEntity(),
				resource.getUiResource("paddis2.jpg").getEntity());
	}
}
